import { Command, Types } from "./command.js";
import logger from "../../logger.js";
import { AccessibilityDump } from "../tasks/accessibility_dump.js";

class GetPageStatus extends Command {
  constructor(recording, longTermMemory) {
    super(Types.GET_PAGE_STATUS, "get current page status", [], recording);
    this.longTermMemory = longTermMemory;
  }

  // eslint-disable-next-line
  async run(context, executeStep = null, taskProgress) {
    await this.preRun(context, taskProgress);
    taskProgress.updateLastCommand({ aiInstruction: "get current page status" });

    logger.info("get current page status");

    const task2 = new AccessibilityDump();
    await task2.execute(context);
    return this.postCommand(this.longTermMemory, taskProgress, context);
  }
}
export { GetPageStatus };
