import { Command, Types } from "./command.js";
class TaskComplete extends Command {
  constructor(reason, recording) {
    super(Types.COMPLETE, "complete the task, shutdown", [{ name: "reason", description: "reason" }], recording);
    this.reason = reason;
    this.recordingStep.parameters = [this.reason];
  }
  async run(context, executeStep = null, taskProgress) {
    if (executeStep) {
      this.reason = executeStep.parameters[0];
    }

    taskProgress.addProgressCommand();
    taskProgress.updateLastCommand({ aiInstruction: "task complete" });
    taskProgress.updateLastCommand({ success: true });
    console.log("Task complete");
    console.log(this.reason);
    return this.postCommand(`task completed with reason: ${this.reason}`, taskProgress, context);
  }
}
export { TaskComplete };
