import { createMatchedModel } from "./lcs.js";
// import fs from "fs";
const compareDumps = (newDump, oldDump) => {
  if (!newDump || !oldDump) return newDump;
  const lines1 = [];
  const lines2 = [];
  const newDumpLines = newDump.split("\n");
  const oldDumpLines = oldDump.split("\n");
  for (let i = 0; i < newDumpLines.length; i++) {
    const line = newDumpLines[i];
    lines1.push({ text: line });
  }
  for (let i = 0; i < oldDumpLines.length; i++) {
    const line = oldDumpLines[i];
    lines2.push({ text: line });
  }
  const result = createMatchedModel(lines1, lines2);
  if (result.lines1Length - result.linesMatchedCount > 10) {
    return newDump;
  }
  const modifyLines = [];
  for (let i = 0; i < lines1.length; i++) {
    const line = lines1[i];
    if (line.matched) {
      modifyLines.push(line.text);
    } else {
      if (line.text.endsWith("},")) {
        modifyLines.push(line.text.replace(/\},$/g, ", modified_by_last_operation: true},"));
      } else {
        modifyLines.push(line.text.replace(/\}$/g, ", modified_by_last_operation: true}"));
      }
    }
  }
  return modifyLines.join("\n");
};
// let file1 = "test/data/f2.txt";
// let file2 = "test/data/f1.txt";
// let lines1 = fs.readFileSync(file1, "utf8");
// let lines2 = fs.readFileSync(file2, "utf8");
// let result = compareDumps(lines1, lines2);
// console.log(result);

export { compareDumps };
