// const ElementTypes = {
//   FORM: "form",
//   ROW: "row",
//   ACTION: "action",
//   TEXT: "text",
//   IGNORED: "ignored",
// };
// class Element {
//   localId = -1;
//   constructor(location = { top: null, left: null, width: null, height: null }, tagName = null) {
//     this.tagName = tagName;
//     this.attributes = {};
//     this.location = location;
//     this.innerText = null;
//     this.textContent = null;
//     this.formParentId = null;
//     this.formId = -1;
//     this.locator = null;
//     this.parentsSizes = [];
//     this.disabled = false;
//     this.background = false;
//     this.parentInnerText = null;
//     this.value = null;
//     this.rowData = null;
//     this.rowActionElements = [];
//     this.visible = true;
//     this.onScreen = true;
//     this.value = null;
//     this.options = [];
//   }

//   fromJson = (json) => {
//     this.tagName = json.tagName;
//     this.attributes = json.attributes;
//     this.location = json.location;
//     this.innerText = json.innerText;
//     this.textContent = json.textContent;
//     if (this.tagName === "form") {
//       this.formId = json.formUniqueId;
//     } else {
//       this.formParentId = json.formUniqueId;
//     }
//     this.locator = json.locator;
//     this.parentsSizes = json.parentsSizes;
//     this.disabled = json.disabled;
//     this.background = json.background;
//     this.parentInnerText = json.parentInnerText;
//     this.value = json.value;
//     this.visible = json.visible;
//     this.onScreen = json.onScreen;
//     this.value = json.value;
//     this.options = json.options;
//     this.label = json.label;
//   };
//   isForm = () => {
//     return this.tagName === "form";
//   };
//   isRow = () => {
//     return this.tagName === "tr" || this.attributes["role"] === "row";
//   };
//   isButton = () => {
//     return (
//       this.tagName === "button" ||
//       this.attributes["role"] === "button" ||
//       this.attributes["type"] === "button" ||
//       this.attributes["type"] === "submit"
//     );
//   };
//   isSelect = () => {
//     return this.tagName === "select" || this.attributes["role"] === "select";
//   };
//   isInput = () => {
//     return this.tagName === "input";
//   };
//   isCheckbox = () => {
//     return (
//       (this.tagName === "input" && this.attributes["type"] === "checkbox") || this.attributes["role"] === "checkbox"
//     );
//   };
//   isLink = () => {
//     return this.tagName === "a";
//   };
//   getElementType = () => {
//     if (this.innerText === "Skip to Jira Navigation") {
//       console.log("found it");
//     }
//     if (
//       !this.locator ||
//       this.location.width < 5 ||
//       this.location.height < 5 ||
//       this.visible === false ||
//       this.background === true ||
//       ((this.location.top < 0 || this.location.left < 0) && this.onScreen === false)
//     ) {
//       return ElementTypes.IGNORED;
//     }
//     if (this.isForm()) {
//       return ElementTypes.FORM;
//     }
//     if (this.isRow()) {
//       return ElementTypes.ROW;
//     }
//     if (this.isButton() || this.isCheckbox() || this.isLink() || this.isInput()) {
//       return ElementTypes.ACTION;
//     } else {
//       return ElementTypes.TEXT;
//     }
//   };

//   isVerticalyOverlap = (location) => {
//     const topA = this.location.top;
//     const bottomA = this.location.top + this.location.height;
//     const topB = location.top;
//     const bottomB = location.top + location.height;
//     if (topA >= bottomB || topB >= bottomA) {
//       // Rectangles don't overlap vertically
//       return false;
//     } else {
//       // Rectangles overlap vertically
//       return true;
//     }
//   };
//   findCommonParent = (element1) => {
//     if (element1 === null) {
//       return null;
//     }
//     if (element1 === this) {
//       return null;
//     }
//     for (let i = 0; i < element1.parentsSizes.length; i++) {
//       let parentRect = element1.parentsSizes[i];
//       if (this.isContained(parentRect)) {
//         return parentRect;
//       }
//     }
//     return null;
//   };
//   isContained = (location) => {
//     const leftB = this.location.left;
//     const rightB = this.location.left + this.location.width;
//     const topB = this.location.top;
//     const bottomB = this.location.top + this.location.height;

//     const leftA = location.left;
//     const rightA = location.left + location.width;
//     const topA = location.top;
//     const bottomA = location.top + location.height;

//     if (leftB < leftA || rightB > rightA || topB < topA || bottomB > bottomA) {
//       // Rectangles don't overlap
//       return false;
//     } else {
//       // Rectangles overlap
//       return true;
//     }
//   };

//   isOverlap = (location) => {
//     const leftA = this.location.left;
//     const rightA = this.location.left + this.location.width;
//     const topA = this.location.top;
//     const bottomA = this.location.top + this.location.height;

//     const leftB = location.left;
//     const rightB = location.left + location.width;
//     const topB = location.top;
//     const bottomB = location.top + location.height;

//     if (leftB < leftA || rightB > rightA || topB < topA || bottomB > bottomA) {
//       // Rectangles don't overlap
//       return false;
//     } else {
//       // Rectangles overlap
//       return true;
//     }
//   };

//   getReadableType = () => {
//     switch (this.tagName) {
//       case "form":
//         return "form";
//       case "input":
//         if (this.attributes["role"]) {
//           if (this.attributes["role"] === "checkbox") {
//             return "checkbox";
//           }
//           if (this.attributes["role"] === "radio") {
//             return "radio button";
//           }
//         }
//         let text = "";
//         switch (this.attributes["type"]) {
//           case "text":
//             text = "text input";
//             break;
//           case "submit":
//             text = "submit button";
//             break;
//           case "button":
//             if (this.attributes["type"] === "submit") {
//               text = "submit button";
//             } else {
//               text = "button";
//             }
//             break;
//           case "checkbox":
//             text = "checkbox";
//             break;
//           case "radio":
//             text = "radio button";
//             break;
//           case "password":
//             text = "password input";
//             break;
//           case "email":
//             text = "email input";
//             break;
//           case "tel":
//             text = "telephone input";
//             break;
//           case "number":
//             text = "number input";
//             break;
//           case "date":
//             text = "date input";
//             break;
//           case "time":
//             text = "time input";
//             break;
//           default:
//             text = "input";
//             break;
//         }
//         return text;
//       case "button":
//         if (this.attributes["type"] === "submit") {
//           return "submit button";
//         }
//         return "button";
//       case "a":
//         return "link";
//       case "img":
//         return "image";
//       case "select":
//         return "select";
//       case "textarea":
//         return "textarea";
//       default:
//         if (this.isRow()) {
//           return "row";
//         }
//         return this.tagName;
//     }
//   };
//   getSimpleName = () => {
//     let text = "N/A";
//     if (this.attributes["placeholder"] && this.attributes["placeholder"].trim()) {
//       return "text: " + this.attributes["placeholder"];
//     } else if (this.attributes["alt"]) {
//       return "alt: " + this.attributes["alt"];
//     } else if (this.attributes["name"]) {
//       return "name: " + this.attributes["name"];
//     } else if (this.attributes["role"]) {
//       let additionalText = "";
//       if (this.attributes["aria-label"]) {
//         additionalText += ", aria-label: " + this.attributes["aria-label"];
//       }
//       if (this.attributes["aria-checked"]) {
//         additionalText += ", aria-checked: " + this.attributes["aria-checked"];
//       }
//       return "role: " + this.attributes["role"] + additionalText;
//     } else if (this.attributes["title"]) {
//       return "title: " + this.attributes["title"];
//     } else if (this.attributes["action"]) {
//       return "action: " + this.attributes["action"];
//     } else if (this.attributes["id"]) {
//       return "identifier: " + this.attributes["id"];
//     } else if (this.innerText) {
//       return "text: " + this.innerText.replace(/\s+/g, " ").trim();
//     }
//     return text;
//     //return this.getReadableType() + " - " + text;
//   };
//   getText = () => {
//     if (this.label) {
//       return this.label;
//     }
//     if (this.attributes["aria-label"]) {
//       return this.attributes["aria-label"];
//     }
//     let text = this.innerText ? this.innerText.trim().replace(/\s\s+/g, " ").trim() : this.getSimpleName();
//     if ((!text.trim() || text === "N/A") && this.parentInnerText) {
//       text = this.parentInnerText;
//     }
//     return text;
//   };
//   toString = (longVersion = true) => {
//     if (this.tagName === "form") {
//       return "start form:"; // + this.getSimpleName();
//     }
//     const type = this.getReadableType();
//     const disabled = this.disabled ? "true" : "false";
//     let text = this.getText();
//     let cssSelector = this.locator ? this.locator : "N/A";
//     // if the cssSelector is over 60 characters, we will trim it
//     if (cssSelector.length > 60) {
//       cssSelector = cssSelector.substring(0, 60) + "...";
//     }
//     const value = this.value ? this.value : "N/A";
//     let cssSelectorText = "";
//     if (longVersion) {
//       cssSelectorText = `, css selector: ${cssSelector}`;
//     }
//     let disabledText = "";
//     if (this.disabled || longVersion) {
//       disabledText = `, disabled: ${disabled}`;
//     }
//     return `${type}, ${text}${type.includes("input") ? ", value: " + value : ""}${cssSelectorText}${disabledText}`;
//   };
//   toAssentJson = () => {
//     if (this.getElementType() === ElementTypes.TEXT) {
//       return `{ text: ${JSON.stringify(this.toTextString())} }`;
//     }
//     if (this.isRow()) {
//       if (!this.rowData) {
//         return `{ row: "N/A",`;
//       }

//       return `{ row: ${JSON.stringify(this.rowData.join(", "))},`;
//     }
//     let text = this.getText();

//     let disabledText = "";
//     if (this.disabled) {
//       disabledText = `, disabled: true`;
//     }
//     let valueText = "";
//     if (this.value) {
//       valueText = `, value: ${JSON.stringify(this.value)}`;
//     }

//     const result = `{ id: ${this.localId}, type: "${this.getReadableType()}", description: ${JSON.stringify(
//       text.replace(/\s+/g, " ").trim()
//     )}${valueText}${disabledText}}`;

//     return result;
//   };

//   toTextString = () => {
//     if (this.tagName === "form") {
//       return "start form:"; // + this.getSimpleName();
//     }
//     if (this.innerText) {
//       return this.innerText.trim().replace(/\s\s+/g, " ");
//     }
//     if (this.tagName === "input" && this.value) {
//       return this.getSimpleName() + " - " + this.value;
//     }
//     return this.getSimpleName();
//   };
// }
// export { Element as default, ElementTypes };
