// import Element from "./element.js";
// import { ElementTypes } from "./element.js";

// import logger from "../../../logger.js";
// import fs from "fs";
// const elementSorter = (elementsArray, scanStart) => {
//   if (elementsArray.length <= scanStart + 1) {
//     return;
//   }
//   // find top level elements
//   let topValue = Number.MAX_SAFE_INTEGER;
//   let topElement = null;
//   for (let i = scanStart; i < elementsArray.length; i++) {
//     if (elementsArray[i].location.top < topValue) {
//       topValue = elementsArray[i].location.top;
//       topElement = elementsArray[i];
//     }
//   }
//   if (topElement === null) {
//     return;
//   }
//   // find all elements that are vertically overlap with the top element
//   let verticalOverlap = [];
//   for (let i = scanStart; i < elementsArray.length; i++) {
//     if (elementsArray[i].isVerticalyOverlap(topElement.location)) {
//       verticalOverlap.push(elementsArray[i]);
//       // remove the element from the array
//       elementsArray.splice(i, 1);
//       i--;
//     }
//   }
//   // soft horizontally
//   verticalOverlap.sort((a, b) => {
//     return a.location.left - b.location.left;
//   });
//   // add the vertical overlap to the scanStart index
//   elementsArray.splice(scanStart, 0, ...verticalOverlap);
//   scanStart += verticalOverlap.length;
//   // recursive call
//   elementSorter(elementsArray, scanStart);
// };

// class ElementsGroup extends Element {
//   constructor(elements, rect) {
//     super();
//     this.tagName = "group";
//     this.elements = elements;
//     this.location = rect;
//     this.isTable = false;
//     for (let i = 0; i < elements[0].parentsSizes.length; i++) {
//       let parentLocation = elements[0].parentsSizes[i];
//       if (
//         parentLocation.top === rect.top &&
//         parentLocation.left === rect.left &&
//         parentLocation.width === rect.width &&
//         parentLocation.height === rect.height
//       ) {
//         this.parentsSizes = elements[0].parentsSizes.slice(i + 1);
//         break;
//       }
//     }
//     if (this.parentsSizes.length === 0) {
//       console.log("ElementsGroup with no parents sizes was created");
//     }
//     for (let i = 0; i < elements.length; i++) {
//       if (elements[i].isRow()) {
//         this.isTable = true;
//         break;
//       }
//     }
//   }
// }

// class ElementContainer {
//   constructor(element, length) {
//     this.element = element;
//     this.elementsRectsSizes = new Array(length).fill(null);
//     this.smallestValue = Number.MAX_SAFE_INTEGER;
//     this.smallestIndex = -1;
//     this.form = false;
//   }
//   calculateSmallestValue() {
//     for (let i = 0; i < this.elementsRectsSizes.length; i++) {
//       if (this.elementsRectsSizes[i] === null) {
//         continue;
//       }
//       if (this.elementsRectsSizes[i] < this.smallestValue) {
//         this.smallestValue = this.elementsRectsSizes[i];
//         this.smallestIndex = i;
//       }
//     }
//   }
// }

// const createElementsGroups = (elementsArray) => {
//   let somethingChanged = false;
//   if (elementsArray.length === 0 || elementsArray.length === 1) {
//     return { somethingChanged: false, elementsArray };
//   }
//   //sort elements by top left
//   elementsArray.sort((a, b) => {
//     if (a.location.top === b.location.top) {
//       if (a.location.left === b.location.left) {
//         return (
//           b.location.width * b.location.height -
//           a.location.width * a.location.height
//         );
//       }
//       return a.location.left - b.location.left;
//     }
//     return a.location.top - b.location.top;
//   });
//   const elementContainers = [];
//   for (let i = 0; i < elementsArray.length; i++) {
//     elementContainers.push(
//       new ElementContainer(elementsArray[i], elementsArray.length)
//     );
//   }
//   for (let i = 0; i < elementsArray.length; i++) {
//     let element1 = elementsArray[i];
//     for (let j = i + 1; j < elementsArray.length; j++) {
//       if (i === j) {
//         continue;
//       }
//       let element2 = elementsArray[j];

//       let commonParent = element2.findCommonParent(element1);
//       if (commonParent === null) {
//         continue;
//       }
//       elementContainers[i].elementsRectsSizes[j] =
//         commonParent.width * commonParent.height;
//       elementContainers[j].elementsRectsSizes[i] =
//         commonParent.width * commonParent.height;
//     }
//   }
//   for (let i = 0; i < elementContainers.length; i++) {
//     elementContainers[i].calculateSmallestValue();
//   }
//   for (let i = 0; i < elementContainers.length; i++) {
//     let elementContainer1 = elementContainers[i];
//     if (elementContainer1.smallestIndex === -1) {
//       continue;
//     }
//     let elementContainer2 = elementContainers[elementContainer1.smallestIndex];
//     // find other elements that are contained in the same rect
//     let rect = elementContainer2.element.findCommonParent(
//       elementContainer1.element
//     );
//     if (rect === null) {
//       continue;
//     }
//     let groupCandidates = [];
//     groupCandidates.push(i);
//     groupCandidates.push(elementContainer1.smallestIndex);

//     let breakAll = false;
//     for (let j = 0; j < elementContainers.length; j++) {
//       // skip the element itself and the smallest element
//       if (i === j || elementContainer1.smallestIndex === j) {
//         continue;
//       }
//       let elementContainer3 = elementContainers[j];
//       if (elementContainer3.smallestIndex === -1) {
//         continue;
//       }
//       if (elementContainer3.element.isContained(rect)) {
//         if (
//           elementContainer3.smallestValue !== elementContainer1.smallestValue
//         ) {
//           breakAll = true;
//           break;
//         }
//         groupCandidates.push(j);
//       }
//     }
//     if (breakAll) {
//       continue;
//     }
//     // create a group add the candidates, remove them from the list and add the group to the list
//     somethingChanged = true;
//     let elArray = [];
//     for (let i = 0; i < groupCandidates.length; i++) {
//       elArray.push(elementContainers[groupCandidates[i]].element);
//     }
//     let elementsGroup = new ElementsGroup(elArray, rect);
//     if (elArray[0].isForm()) {
//       elementsGroup.form = true;
//     }
//     let offset = 0;
//     groupCandidates.sort((a, b) => a - b);
//     for (let i = 0; i < groupCandidates.length; i++) {
//       elementsArray.splice(groupCandidates[i] - offset, 1);
//       offset++;
//     }
//     elementsArray.push(elementsGroup);
//     return { somethingChanged, elementsArray };
//   }
// };

// const generatePrintResult = (
//   elementsArray,
//   result,
//   indexObj,
//   flatElements,
//   root
// ) => {
//   for (let i = 0; i < elementsArray.length; i++) {
//     let element = elementsArray[i];
//     // check the type of result
//     if (!Array.isArray(result)) {
//       result.page = [];
//       result = result.page;
//     }
//     if (element instanceof ElementsGroup) {
//       if (element.form) {
//         let form = [];
//         result.push({ form });
//         generatePrintResult(
//           element.elements,
//           form,
//           indexObj,
//           flatElements,
//           root
//         );
//       } else if (element.isTable) {
//         let table = [];
//         result.push({ table });
//         generatePrintResult(
//           element.elements,
//           table,
//           indexObj,
//           flatElements,
//           root
//         );
//       } else {
//         if (element.elements && element.elements.length > 0) {
//           generatePrintResult(
//             element.elements,
//             result,
//             indexObj,
//             flatElements,
//             root
//           );
//         }
//       }
//     } else {
//       if (!element.isForm()) {
//         if (element.isRow()) {
//           if (
//             element.rowActionElements &&
//             element.rowActionElements.length > 0
//           ) {
//             for (let j = 0; j < element.rowActionElements.length; j++) {
//               element.rowActionElements[j].localId = indexObj.index;
//               indexObj.index++;
//               flatElements.push(element.rowActionElements[j]);
//             }
//           }
//         } else if (element.getElementType() !== ElementTypes.TEXT) {
//           element.localId = indexObj.index;
//           indexObj.index++;
//           flatElements.push(element);
//         }
//         result.push(element);
//         //texts.push(startText + element.toString());
//       }
//     }
//   }
// };
// const printResult = (lines, tab, result) => {
//   if (result instanceof Element) {
//     if (result.isRow()) {
//       lines.push(tab + result.toAssentJson());
//       if (result.rowActionElements && result.rowActionElements.length > 0) {
//         lines.push(tab + "  actions: [");
//         for (let i = 0; i < result.rowActionElements.length; i++) {
//           printResult(lines, tab + "    ", result.rowActionElements[i]);
//         }
//         lines.push(tab + "  ],");
//       }
//       lines.push(tab + "},");
//       return;
//     }
//     lines.push(tab + result.toAssentJson() + ",");
//     return;
//   } else {
//     for (let key in result) {
//       if (Array.isArray(result[key])) {
//         if (key === "table") {
//           lines.push(tab + `{ table: [`);
//           tab += "  ";
//         } else {
//           lines.push(tab + `${key}` + ": [");
//         }
//         for (let i = 0; i < result[key].length; i++) {
//           printResult(lines, tab + "  ", result[key][i]);
//         }
//         lines.push(tab + "],");
//         if (key === "table") {
//           tab = tab.substring(0, tab.length - 2);
//           lines.push(tab + "},");
//         }
//       } else {
//         printResult(lines, tab, result[key]);
//       }
//     }
//   }
// };
// class PageBeautify2 {
//   constructor(filterText = true) {
//     this.type = "page_beautify";
//     this.filterText = filterText;
//   }

//   async execute(context) {
//     const elements = [];
//     for (let i = 0; i < context.dump._elements.length; i++) {
//       const element = context.dump._elements[i];
//       // const element = new Element();
//       // element.fromJson(context.dump._elements[i]);
//       if (element.getElementType() !== ElementTypes.IGNORED) {
//         elements.push(element);
//       }
//     }

//     // group elements
//     let elementsGrop = elements;
//     for (let i = 0; i < 100; i++) {
//       let result = createElementsGroups(elementsGrop);
//       if (!result) {
//         break;
//       }
//       elementsGrop = result.elementsArray;
//       if (!result.somethingChanged) {
//         break;
//       }
//     }
//     const result = {};
//     const indexObj = { index: 1, rowIndex: 1 };
//     let flatElements = [];
//     generatePrintResult(elements, result, indexObj, flatElements, result);
//     let lines = [];
//     lines.push("{");
//     lines.push(`  title: ${JSON.stringify(context.dump.title)},`);
//     lines.push(`  url: ${JSON.stringify(context.url)},`);
//     printResult(lines, "  ", result);
//     lines.push("}");

//     context.interactionElementsText = lines.join("\n");
//     context.elements = flatElements;
//     context.previousPageLines = context.pageLines;
//     context.pageLines = lines;
//     context.pageText = lines.join("\n");
//     //logger.info(context.pageText);
//   }
//   getChangedTextHighlights(context) {
//     if (context.previousUrl && context.url === context.previousUrl) {
//       let newLines = [...context.pageTextLines];
//       let indexes = this.pageTextCompareIndexes(
//         context.previousPageLines,
//         context.pageTextLines
//       );
//       for (let i = 0; i < indexes.length; i++) {
//         newLines[indexes[i]] =
//           newLines[indexes[i]] + " << changed from previous operation";
//       }
//       return newLines;
//     }
//     return context.pageTextLines;
//   }
//   pageTextCompareIndexes = (previousLines, currentLines) => {
//     const changeLinesIndexes = [];
//     if (!previousLines || !currentLines) {
//       return changeLinesIndexes;
//     }
//     for (let i = 0; i < currentLines.length; i++) {
//       const line = currentLines[i];
//       for (let j = 0; j < previousLines.length; j++) {
//         const prevLine = previousLines[j];
//         if (line === prevLine) {
//           break;
//         }
//         if (j === previousLines.length - 1) {
//           changeLinesIndexes.push(i);
//         }
//       }
//     }
//     return changeLinesIndexes;
//   };
// }

// export {
//   PageBeautify2 as default,
//   // createElementsGroups,
//   // ElementContainer,
//   // ElementsGroup,
// };
