// import Element from "../src/tasks/beautify/element.js";
// import { expect as expect } from "chai";

// describe("Element", () => {
//   it("should create an instance of Element with default values", () => {
//     const element = new Element();
//     expect(element.tagName).to.be.null;
//     expect(element.attributes).to.be.empty;
//     expect(element.location).to.eql({
//       top: null,
//       left: null,
//       width: null,
//       height: null,
//     });
//     expect(element.innerText).to.be.null;
//     expect(element.textContent).to.be.null;
//     expect(element.formParentId).to.be.null;
//     expect(element.formId).to.equal(-1);
//     expect(element.locator).to.be.null;
//     expect(element.parentsSizes).to.eql([]);
//     expect(element.disabled).to.be.false;
//     expect(element.background).to.be.false;
//     expect(element.parentInnerText).to.be.null;
//     expect(element.value).to.be.null;
//   });

//   it("should set instance properties from a JSON object", () => {
//     const json = {
//       tagName: "input",
//       attributes: {
//         type: "text",
//       },
//       location: {
//         top: 10,
//         left: 20,
//         width: 100,
//         height: 50,
//       },
//       innerText: "Example Text",
//       textContent: null,
//       formParentId: 123,
//       formUniqueId: 321,
//       locator: "#example",
//       parentsSizes: [200, 300],
//       disabled: true,
//       background: false,
//       parentInnerText: "Parent Text",
//       value: "Example Value",
//     };
//     const element = new Element();
//     element.fromJson(json);
//     expect(element.tagName).to.equal("input");
//     expect(element.attributes).to.eql({ type: "text" });
//     expect(element.location).to.eql({
//       top: 10,
//       left: 20,
//       width: 100,
//       height: 50,
//     });
//     expect(element.innerText).to.equal("Example Text");
//     expect(element.textContent).to.be.null;
//     expect(element.formParentId).to.equal(321);
//     expect(element.formId).to.equal(-1);
//     expect(element.locator).to.equal("#example");
//     expect(element.parentsSizes).to.eql([200, 300]);
//     expect(element.disabled).to.be.true;
//     expect(element.background).to.be.false;
//     expect(element.parentInnerText).to.equal("Parent Text");
//     expect(element.value).to.equal("Example Value");
//   });

//   it("should check if element is a form", () => {
//     const element = new Element({}, "form");
//     expect(element.isForm()).to.be.true;
//     expect(new Element({}, "input").isForm()).to.be.false;
//   });

//   it("should check if two elements overlap vertically", () => {
//     const elementA = new Element({
//       top: 10,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementB = new Element({
//       top: 80,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementC = new Element({
//       top: 120,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     expect(elementA.isVerticalyOverlap(elementB.location)).to.be.true;
//     expect(elementA.isVerticalyOverlap(elementC.location)).to.be.false;
//   });

//   it("should check if an element is contained in another element", () => {
//     const container = new Element({ top: 0, left: 0, width: 200, height: 200 });
//     const elementA = new Element({
//       top: 10,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementB = new Element({
//       top: 10,
//       left: 150,
//       width: 100,
//       height: 100,
//     });
//     const elementC = new Element({
//       top: 150,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementD = new Element({
//       top: 150,
//       left: 150,
//       width: 100,
//       height: 100,
//     });
//     const elementE = new Element({
//       top: 0,
//       left: 0,
//       width: 300,
//       height: 300,
//     });
//     expect(container.isContained(elementA.location)).to.be.false;
//     expect(container.isContained(elementB.location)).to.be.false;
//     expect(container.isContained(elementC.location)).to.be.false;
//     expect(container.isContained(elementD.location)).to.be.false;
//     expect(container.isContained(elementE.location)).to.be.true;
//   });

//   it("should check if two elements overlap", () => {
//     const elementA = new Element({
//       top: 10,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementB = new Element({
//       top: 80,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementC = new Element({
//       top: 150,
//       left: 10,
//       width: 100,
//       height: 100,
//     });
//     const elementD = new Element({
//       top: 150,
//       left: 150,
//       width: 100,
//       height: 100,
//     });
//     expect(elementA.isOverlap(elementB.location)).to.be.false;
//     expect(elementA.isOverlap(elementC.location)).to.be.false;
//     expect(elementA.isOverlap(elementD.location)).to.be.false;
//   });

//   it("should get a readable type based on element tagName and attribute type", () => {
//     const input = new Element({}, "input");
//     input.attributes["type"] = "text";
//     expect(input.getReadableType()).to.equal("text input");
//     input.attributes["type"] = "submit";
//     expect(input.getReadableType()).to.equal("submit button");
//     input.attributes["type"] = "button";
//     expect(input.getReadableType()).to.equal("button");
//     input.attributes["type"] = "checkbox";
//     expect(input.getReadableType()).to.equal("checkbox");
//     input.attributes["type"] = "radio";
//     expect(input.getReadableType()).to.equal("radio button");
//     input.attributes["type"] = "password";
//     expect(input.getReadableType()).to.equal("password input");
//     input.attributes["type"] = "email";
//     expect(input.getReadableType()).to.equal("email input");
//     input.attributes["type"] = "tel";
//     expect(input.getReadableType()).to.equal("telephone input");
//     input.attributes["type"] = "number";
//     expect(input.getReadableType()).to.equal("number input");
//     input.attributes["type"] = "date";
//     expect(input.getReadableType()).to.equal("date input");
//     input.attributes["type"] = "time";
//     expect(input.getReadableType()).to.equal("time input");
//     input.attributes["type"] = undefined;
//     expect(input.getReadableType()).to.equal("input");
//     expect(new Element({}, "form").getReadableType()).to.equal("form");
//     expect(new Element({}, "button").getReadableType()).to.equal("button");
//     const a = new Element({}, "a");
//     expect(a.getReadableType()).to.equal("link");
//     const img = new Element({}, "img");
//     expect(img.getReadableType()).to.equal("image");
//     expect(new Element({}, "select").getReadableType()).to.equal("select");
//     expect(new Element({}, "textarea").getReadableType()).to.equal("textarea");
//     expect(new Element({}, "other").getReadableType()).to.equal("other");
//   });

//   it("should get a simple name based on element attributes", () => {
//     const input = new Element({});
//     input.attributes["placeholder"] = "Placeholder";
//     expect(input.getSimpleName()).to.equal("text: Placeholder");
//     input.attributes["placeholder"] = undefined;
//     input.attributes["alt"] = "Alternate Text";
//     expect(input.getSimpleName()).to.equal("alt: Alternate Text");
//     input.attributes["alt"] = undefined;
//     input.attributes["name"] = "Name";
//     expect(input.getSimpleName()).to.equal("name: Name");
//     input.attributes["name"] = undefined;
//     input.attributes["role"] = "Role";
//     expect(input.getSimpleName()).to.equal("role: Role");
//     input.attributes["role"] = undefined;
//     input.attributes["action"] = "Action";
//     expect(input.getSimpleName()).to.equal("action: Action");
//     input.attributes["action"] = undefined;
//     input.attributes["title"] = "Title";
//     expect(input.getSimpleName()).to.equal("title: Title");
//     input.attributes["title"] = undefined;
//     input.attributes["id"] = "ID";
//     expect(input.getSimpleName()).to.equal("identifier: ID");
//     input.attributes["id"] = undefined;
//     input.innerText = "Inner Text  ";
//     expect(input.getSimpleName()).to.equal("text: Inner Text");
//     expect(new Element({}).getSimpleName()).to.equal("N/A");
//   });

//   it("should get element text", () => {
//     const input = new Element({});
//     input.innerText = " Inner  Text ";
//     expect(input.getText()).to.equal("Inner Text");
//     input.innerText = undefined;
//     input.value = "Value";
//     input.attributes["name"] = "Name";
//     expect(input.getText()).to.equal("name: Name");
//     input.innerText = " Inner  Text ";
//     input.value = undefined;
//     expect(input.getText()).to.equal("Inner Text");
//     expect(new Element({}).getText()).to.equal("N/A");
//   });

//   it("should convert element to a string", () => {
//     const input = new Element(
//       { top: 10, left: 10, width: 100, height: 50 },
//       "input"
//     );
//     input.attributes["type"] = "text";
//     input.attributes["id"] = "InputID";
//     input.attributes["placeholder"] = "Input Placeholder";
//     input.disabled = true;
//     input.locator = '#mainContainer > input#InputID[type="text"]';
//     expect(input.toString()).to.equal(
//       'text input, text: Input Placeholder, value: N/A, css selector: #mainContainer > input#InputID[type="text"], disabled: true'
//     );
//     const form = new Element(
//       { top: 20, left: 20, width: 200, height: 150 },
//       "form"
//     );
//     expect(form.toString()).to.equal("start form:");
//   });

//   // it("should convert element to a text string", () => {
//   //   const input = new Element(
//   //     { top: 10, left: 10, width: 100, height: 50 },
//   //     "input"
//   //   );
//   //   input.attributes["type"] = "text";
//   //   input.attributes["id"] = "InputID";
//   //   input.attributes["placeholder"] = "Input Placeholder";
//   //   expect(input.toTextString()).to.equal("Input Placeholder");
//   //   input.attributes["placeholder"] = undefined;
//   //   input.innerText = undefined;
//   //   input.value = "Input Value";
//   //   input.attributes["name"] = "Input Name";
//   //   expect(input.toTextString()).to.equal("Input Name - Input Value");
//   //   input.innerText = " Inner  Text ";
//   //   input.value = undefined;
//   //   expect(input.toTextString()).to.equal("Inner Text");
//   //   const form = new Element(
//   //     { top: 20, left: 20, width: 200, height: 150 },
//   //     "form"
//   //   );
//   //   expect(form.toTextString()).to.equal("start form:");
//   //   expect(new Element({}).toTextString()).to.equal("N/A");
//   // });
// });
