import { runPrompt } from "../src/tasks/openai/prompt_runner.js";
// const webPage = `logo image
// start  form
//     username text input field css selector: [name="username"]
//     password password input field css selector: [name="password"]
//     Forgot password? link
//     Login button css selector: [class="button-by-design primary main-action-button main-action-button-login"]
// end form`;
// const url = "https://uscloud.experitest.com/#/login";

const webPage2 = `page title: seetest cloud login
url: https://cloud.seetest.io/login
important elements:
button - menu_topdown, css selector: [id="menu_topdown"]
button - top_navbar_tests, css selector: [id="top_navbar_tests"]
button - bell_icon, css selector: [id="bell_icon"]
link - text: Device host machine Status, css selector: [href="#/host-machines/device-host-machines"]
link - text: Project Usage, css selector: [href="/#/projects"]
link - text: Dashboard, css selector: [href="#/dashboard"]
link - text: Browsers & Emulators, css selector: [href="#/browsers-and-emulators/browsers"]
link - text: Automation, css selector: [href="#/quickstart"]
link - text: Execution, css selector: [href="#/execution"]
link - text: Reports, css selector: [href="#/test-results"]
link - text: Applications, css selector: [href="#/applications"]
button - Settings, css selector: [class="side-navbar-settings"]
link - text: Reservations History, css selector: [href="#/diagnose/usage-reports"]
link - text: Selenium Agents, css selector: [href="#/host-machines/selenium-agents"]
link - text: Events, css selector: [href="/#/diagnose/cloud-events"]`;

const goals = `
1. open the environment. 
2. navigate to the requested page (login if needed).
3. Click the login button and wait for the page to load.
4. Verify that the login was successful by checking for the presence of the user's profile picture or username on the dashboard page.
5. If the login was unsuccessful, provide an error message indicating the reason for the failure.`;

const map = {
  goals,
  task: "navigate to the users page",
  content: webPage2,
  remember: "requested to call get_current_page_details",
};

const result1 = await runPrompt(
  "/Users/guyarieli/Documents/GitHub/ai-qa/logic/src/tasks/openai/prompts/navigation.txt",
  map
);
console.log(result1.message.content);
console.log(result1.finish_reason);
